Index: branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90
===================================================================
--- branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 3759)
+++ branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 3764)
@@ -17,5 +17,5 @@
    !!             -   !  2008  (R. Benshila) add mpp_ini_ice
    !!            3.2  !  2009  (R. Benshila) SHMEM suppression, north fold in lbc_nfd
-   !!            3.2  !  2009  (O. Marti)    add mpp_ini_znl 
+   !!            3.2  !  2009  (O. Marti)    add mpp_ini_znl
    !!            4.0  !  2011  (G. Madec)  move ctl_ routines from in_out_manager
    !!            3.5  !  2012  (S.Mocavero, I. Epicoco) Add 'mpp_lnk_bdy_3d', 'mpp_lnk_obc_3d', 
@@ -30,5 +30,5 @@
    !!   get_unit    : give the index of an unused logical unit
    !!----------------------------------------------------------------------
-#if   defined key_mpp_mpi  
+#if   defined key_mpp_mpi
    !!----------------------------------------------------------------------
    !!   'key_mpp_mpi'             MPI massively parallel processing library
@@ -55,5 +55,5 @@
    !!   mpp_lbc_north_e : variant of mpp_lbc_north for extra outer halo
    !!----------------------------------------------------------------------
-   USE dom_oce        ! ocean space and time domain 
+   USE dom_oce        ! ocean space and time domain
    USE lbcnfd         ! north fold treatment
    USE in_out_manager ! I/O manager
@@ -61,5 +61,5 @@
    IMPLICIT NONE
    PRIVATE
-   
+
    PUBLIC   ctl_stop, ctl_warn, get_unit, ctl_opn
    PUBLIC   mynode, mppstop, mppsync, mpp_comm_free
@@ -70,5 +70,5 @@
    PUBLIC   mppobc, mpp_ini_ice, mpp_ini_znl
    PUBLIC   mppsize
-   PUBLIC   mppsend, mpprecv                          ! needed by ICB routines
+   PUBLIC   mppsend, mpprecv                          ! needed by TAM and ICB routines
    PUBLIC   lib_mpp_alloc   ! Called in nemogcm.F90
    PUBLIC   mpp_lnk_bdy_2d, mpp_lnk_bdy_3d
@@ -90,5 +90,5 @@
    END INTERFACE
    INTERFACE mpp_lbc_north
-      MODULE PROCEDURE mpp_lbc_north_3d, mpp_lbc_north_2d 
+      MODULE PROCEDURE mpp_lbc_north_3d, mpp_lbc_north_2d
    END INTERFACE
    INTERFACE mpp_minloc
@@ -98,5 +98,5 @@
       MODULE PROCEDURE mpp_maxloc2d ,mpp_maxloc3d
    END INTERFACE
-   
+
    !! ========================= !!
    !!  MPI  variable definition !!
@@ -105,9 +105,9 @@
    INCLUDE 'mpif.h'
 !$AGRIF_END_DO_NOT_TREAT
-   
+
    LOGICAL, PUBLIC, PARAMETER ::   lk_mpp = .TRUE.    !: mpp flag
 
    INTEGER, PARAMETER         ::   nprocmax = 2**10   ! maximun dimension (required to be a power of 2)
-   
+
    INTEGER ::   mppsize        ! number of process
    INTEGER ::   mpprank        ! process number  [ 0 - size-1 ]
@@ -132,20 +132,20 @@
    INTEGER ::   ndim_rank_znl   ! number of processors on the same zonal average
    INTEGER, DIMENSION(:), ALLOCATABLE, SAVE ::   nrank_znl  ! dimension ndim_rank_znl, number of the procs into the same znl domain
-   
-   ! North fold condition in mpp_mpi with jpni > 1
-   INTEGER ::   ngrp_world        ! group ID for the world processors
-   INTEGER ::   ngrp_opa          ! group ID for the opa processors
-   INTEGER ::   ngrp_north        ! group ID for the northern processors (to be fold)
-   INTEGER ::   ncomm_north       ! communicator made by the processors belonging to ngrp_north
-   INTEGER ::   ndim_rank_north   ! number of 'sea' processor in the northern line (can be /= jpni !)
-   INTEGER ::   njmppmax          ! value of njmpp for the processors of the northern line
-   INTEGER ::   north_root        ! number (in the comm_opa) of proc 0 in the northern comm
-   INTEGER, DIMENSION(:), ALLOCATABLE, SAVE ::   nrank_north   ! dimension ndim_rank_north
+
+   ! North fold condition in mpp_mpi with jpni > 1 (PUBLIC for TAM)
+   INTEGER, PUBLIC ::   ngrp_world        ! group ID for the world processors
+   INTEGER, PUBLIC ::   ngrp_opa          ! group ID for the opa processors
+   INTEGER, PUBLIC ::   ngrp_north        ! group ID for the northern processors (to be fold)
+   INTEGER, PUBLIC ::   ncomm_north       ! communicator made by the processors belonging to ngrp_north
+   INTEGER, PUBLIC ::   ndim_rank_north   ! number of 'sea' processor in the northern line (can be /= jpni !)
+   INTEGER, PUBLIC ::   njmppmax          ! value of njmpp for the processors of the northern line
+   INTEGER, PUBLIC ::   north_root        ! number (in the comm_opa) of proc 0 in the northern comm
+   INTEGER, DIMENSION(:), ALLOCATABLE, SAVE, PUBLIC ::   nrank_north   ! dimension ndim_rank_north
 
    ! Type of send : standard, buffered, immediate
-   CHARACTER(len=1)         ::   cn_mpi_send = 'S'    ! type od mpi send/recieve (S=standard, B=bsend, I=isend)
-   LOGICAL         , PUBLIC ::   l_isend = .FALSE.   ! isend use indicator (T if cn_mpi_send='I')
-   INTEGER                  ::   nn_buffer = 0       ! size of the buffer in case of mpi_bsend 
-      
+   CHARACTER(len=1), PUBLIC ::   cn_mpi_send = 'S'    ! type od mpi send/recieve (S=standard, B=bsend, I=isend)
+   LOGICAL, PUBLIC          ::   l_isend = .FALSE.   ! isend use indicator (T if cn_mpi_send='I')
+   INTEGER, PUBLIC          ::   nn_buffer = 0       ! size of the buffer in case of mpi_bsend
+
    REAL(wp), DIMENSION(:), ALLOCATABLE, SAVE :: tampon  ! buffer in case of bsend
 
@@ -177,5 +177,5 @@
    ! North fold arrays used to minimise the use of allgather operations. Set in nemo_northcomms (nemogcm) so need to be public
    INTEGER, PUBLIC,  PARAMETER :: jpmaxngh = 8                 ! Assumed maximum number of active neighbours
-   INTEGER, PUBLIC,  PARAMETER :: jptyps   = 5                 ! Number of different neighbour lists to be used for northfold exchanges 
+   INTEGER, PUBLIC,  PARAMETER :: jptyps   = 5                 ! Number of different neighbour lists to be used for northfold exchanges
    INTEGER, PUBLIC,  DIMENSION (jpmaxngh,jptyps)    ::   isendto
    INTEGER, PUBLIC,  DIMENSION (jptyps)             ::   nsndto
@@ -228,10 +228,10 @@
       !!----------------------------------------------------------------------
       !!                  ***  routine mynode  ***
-      !!                    
+      !!
       !! ** Purpose :   Find processor unit
       !!----------------------------------------------------------------------
-      CHARACTER(len=*),DIMENSION(:), INTENT(  out) ::   ldtxt 
-      INTEGER                      , INTENT(in   ) ::   kumnam       ! namelist logical unit 
-      INTEGER                      , INTENT(inout) ::   kstop        ! stop indicator 
+      CHARACTER(len=*),DIMENSION(:), INTENT(  out) ::   ldtxt
+      INTEGER                      , INTENT(in   ) ::   kumnam       ! namelist logical unit
+      INTEGER                      , INTENT(inout) ::   kstop        ! stop indicator
       INTEGER, OPTIONAL            , INTENT(in   ) ::   localComm
       !
@@ -257,5 +257,5 @@
 #if defined key_agrif
       IF( .NOT. Agrif_Root() ) THEN
-         jpni  = Agrif_Parent(jpni ) 
+         jpni  = Agrif_Parent(jpni )
          jpnj  = Agrif_Parent(jpnj )
          jpnij = Agrif_Parent(jpnij)
@@ -281,7 +281,7 @@
       CALL mpi_initialized ( mpi_was_called, code )
       IF( code /= MPI_SUCCESS ) THEN
-         DO ji = 1, SIZE(ldtxt) 
+         DO ji = 1, SIZE(ldtxt)
             IF( TRIM(ldtxt(ji)) /= '' )   WRITE(*,*) ldtxt(ji)      ! control print of mynode
-         END DO         
+         END DO
          WRITE(*, cform_err)
          WRITE(*, *) 'lib_mpp: Error in routine mpi_initialized'
@@ -296,5 +296,5 @@
          CASE ( 'B' )                ! Buffer mpi send (blocking)
             WRITE(ldtxt(ii),*) '           Buffer blocking mpi send (bsend)'                      ;   ii = ii + 1
-            IF( Agrif_Root() )   CALL mpi_init_opa( ldtxt, ii, ierr ) 
+            IF( Agrif_Root() )   CALL mpi_init_opa( ldtxt, ii, ierr )
          CASE ( 'I' )                ! Immediate mpi send (non-blocking send)
             WRITE(ldtxt(ii),*) '           Immediate non-blocking send (isend)'                   ;   ii = ii + 1
@@ -329,5 +329,5 @@
       ENDIF
 
-      IF( PRESENT(localComm) ) THEN 
+      IF( PRESENT(localComm) ) THEN
          IF( Agrif_Root() ) THEN
             mpi_comm_opa = localComm
@@ -336,5 +336,5 @@
          CALL mpi_comm_dup( mpi_comm_world, mpi_comm_opa, code)
          IF( code /= MPI_SUCCESS ) THEN
-            DO ji = 1, SIZE(ldtxt) 
+            DO ji = 1, SIZE(ldtxt)
                IF( TRIM(ldtxt(ji)) /= '' )   WRITE(*,*) ldtxt(ji)      ! control print of mynode
             END DO
@@ -343,10 +343,10 @@
             CALL mpi_abort( mpi_comm_world, code, ierr )
          ENDIF
-      ENDIF 
+      ENDIF
 
       CALL mpi_comm_rank( mpi_comm_opa, mpprank, ierr )
       CALL mpi_comm_size( mpi_comm_opa, mppsize, ierr )
       mynode = mpprank
-      ! 
+      !
       CALL MPI_OP_CREATE(DDPDD_MPI, .TRUE., MPI_SUMDD, ierr)
       !
@@ -721,5 +721,5 @@
       !! ** Purpose :   Message passing manadgement
       !!
-      !! ** Method  :   Use mppsend and mpprecv function for passing mask 
+      !! ** Method  :   Use mppsend and mpprecv function for passing mask
       !!      between processors following neighboring subdomains.
       !!            domain parameters
@@ -728,5 +728,5 @@
       !!                    nbondi : mark for "east-west local boundary"
       !!                    nbondj : mark for "north-south local boundary"
-      !!                    noea   : number for local neighboring processors 
+      !!                    noea   : number for local neighboring processors
       !!                    nowe   : number for local neighboring processors
       !!                    noso   : number for local neighboring processors
@@ -741,5 +741,5 @@
       REAL(wp)                        , INTENT(in   ) ::   psgn     ! =-1 the sign change across the north fold boundary
       !                                                             ! =  1. , the sign is kept
-      CHARACTER(len=3), OPTIONAL      , INTENT(in   ) ::   cd_mpp   ! fill the overlap area only 
+      CHARACTER(len=3), OPTIONAL      , INTENT(in   ) ::   cd_mpp   ! fill the overlap area only
       REAL(wp)        , OPTIONAL      , INTENT(in   ) ::   pval     ! background value (used at closed boundaries)
       !!
@@ -762,5 +762,5 @@
          DO jk = 1, jpk
             DO jj = nlcj+1, jpj                 ! added line(s)   (inner only)
-               ptab(nldi  :nlei  , jj          ,jk) = ptab(nldi:nlei,     nlej,jk)   
+               ptab(nldi  :nlei  , jj          ,jk) = ptab(nldi:nlei,     nlej,jk)
                ptab(1     :nldi-1, jj          ,jk) = ptab(nldi     ,     nlej,jk)
                ptab(nlei+1:nlci  , jj          ,jk) = ptab(     nlei,     nlej,jk)
@@ -773,5 +773,5 @@
          END DO
          !
-      ELSE                              ! standard close or cyclic treatment 
+      ELSE                              ! standard close or cyclic treatment
          !
          !                                   ! East-West boundaries
@@ -792,5 +792,5 @@
       ! 2. East and west directions exchange
       ! ------------------------------------
-      ! we play with the neigbours AND the row number because of the periodicity 
+      ! we play with the neigbours AND the row number because of the periodicity
       !
       SELECT CASE ( nbondi )      ! Read Dirichlet lateral conditions
@@ -801,10 +801,10 @@
             t3we(:,jl,:,1) = ptab(iihom +jl,:,:)
          END DO
-      END SELECT  
+      END SELECT
       !
       !                           ! Migrations
       imigr = jpreci * jpj * jpk
       !
-      SELECT CASE ( nbondi ) 
+      SELECT CASE ( nbondi )
       CASE ( -1 )
          CALL mppsend( 2, t3we(1,1,1,1), imigr, noea, ml_req1 )
@@ -832,5 +832,5 @@
             ptab(iihom+jl,:,:) = t3ew(:,jl,:,2)
          END DO
-      CASE ( 0 ) 
+      CASE ( 0 )
          DO jl = 1, jpreci
             ptab(jl      ,:,:) = t3we(:,jl,:,2)
@@ -859,5 +859,5 @@
       imigr = jprecj * jpi * jpk
       !
-      SELECT CASE ( nbondj )     
+      SELECT CASE ( nbondj )
       CASE ( -1 )
          CALL mppsend( 4, t3sn(1,1,1,1), imigr, nono, ml_req1 )
@@ -871,5 +871,5 @@
          IF(l_isend) CALL mpi_wait(ml_req1, ml_stat, ml_err)
          IF(l_isend) CALL mpi_wait(ml_req2, ml_stat, ml_err)
-      CASE ( 1 ) 
+      CASE ( 1 )
          CALL mppsend( 3, t3ns(1,1,1,1), imigr, noso, ml_req1 )
          CALL mpprecv( 4, t3sn(1,1,1,2), imigr, noso )
@@ -885,5 +885,5 @@
             ptab(:,ijhom+jl,:) = t3ns(:,jl,:,2)
          END DO
-      CASE ( 0 ) 
+      CASE ( 0 )
          DO jl = 1, jprecj
             ptab(:,jl      ,:) = t3sn(:,jl,:,2)
@@ -915,8 +915,8 @@
       !!----------------------------------------------------------------------
       !!                  ***  routine mpp_lnk_2d  ***
-      !!                  
+      !!
       !! ** Purpose :   Message passing manadgement for 2d array
       !!
-      !! ** Method  :   Use mppsend and mpprecv function for passing mask 
+      !! ** Method  :   Use mppsend and mpprecv function for passing mask
       !!      between processors following neighboring subdomains.
       !!            domain parameters
@@ -925,5 +925,5 @@
       !!                    nbondi : mark for "east-west local boundary"
       !!                    nbondj : mark for "north-south local boundary"
-      !!                    noea   : number for local neighboring processors 
+      !!                    noea   : number for local neighboring processors
       !!                    nowe   : number for local neighboring processors
       !!                    noso   : number for local neighboring processors
@@ -936,5 +936,5 @@
       REAL(wp)                    , INTENT(in   ) ::   psgn     ! =-1 the sign change across the north fold boundary
       !                                                         ! =  1. , the sign is kept
-      CHARACTER(len=3), OPTIONAL  , INTENT(in   ) ::   cd_mpp   ! fill the overlap area only 
+      CHARACTER(len=3), OPTIONAL  , INTENT(in   ) ::   cd_mpp   ! fill the overlap area only
       REAL(wp)        , OPTIONAL  , INTENT(in   ) ::   pval     ! background value (used at closed boundaries)
       !!
@@ -957,5 +957,5 @@
          ! WARNING pt2d is defined only between nld and nle
          DO jj = nlcj+1, jpj                 ! added line(s)   (inner only)
-            pt2d(nldi  :nlei  , jj          ) = pt2d(nldi:nlei,     nlej)   
+            pt2d(nldi  :nlei  , jj          ) = pt2d(nldi:nlei,     nlej)
             pt2d(1     :nldi-1, jj          ) = pt2d(nldi     ,     nlej)
             pt2d(nlei+1:nlci  , jj          ) = pt2d(     nlei,     nlej)
@@ -967,5 +967,5 @@
          END DO
          !
-      ELSE                              ! standard close or cyclic treatment 
+      ELSE                              ! standard close or cyclic treatment
          !
          !                                   ! East-West boundaries
@@ -986,5 +986,5 @@
       ! 2. East and west directions exchange
       ! ------------------------------------
-      ! we play with the neigbours AND the row number because of the periodicity 
+      ! we play with the neigbours AND the row number because of the periodicity
       !
       SELECT CASE ( nbondi )      ! Read Dirichlet lateral conditions
@@ -1084,5 +1084,5 @@
             pt2d(:,ijhom+jl) = t2ns(:,jl,2)
          END DO
-      CASE ( 1 ) 
+      CASE ( 1 )
          DO jl = 1, jprecj
             pt2d(:,jl      ) = t2sn(:,jl,2)
@@ -1112,5 +1112,5 @@
       !! ** Purpose :   Message passing manadgement for two 3D arrays
       !!
-      !! ** Method  :   Use mppsend and mpprecv function for passing mask 
+      !! ** Method  :   Use mppsend and mpprecv function for passing mask
       !!      between processors following neighboring subdomains.
       !!            domain parameters
@@ -1119,5 +1119,5 @@
       !!                    nbondi : mark for "east-west local boundary"
       !!                    nbondj : mark for "north-south local boundary"
-      !!                    noea   : number for local neighboring processors 
+      !!                    noea   : number for local neighboring processors
       !!                    nowe   : number for local neighboring processors
       !!                    noso   : number for local neighboring processors
@@ -1127,7 +1127,7 @@
       !!
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   ptab1     ! first and second 3D array on which 
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   ptab1     ! first and second 3D array on which
       REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   ptab2     ! the boundary condition is applied
-      CHARACTER(len=1)                , INTENT(in   ) ::   cd_type1  ! nature of ptab1 and ptab2 arrays 
+      CHARACTER(len=1)                , INTENT(in   ) ::   cd_type1  ! nature of ptab1 and ptab2 arrays
       CHARACTER(len=1)                , INTENT(in   ) ::   cd_type2  ! i.e. grid-points = T , U , V , F or W points
       REAL(wp)                        , INTENT(in   ) ::   psgn      ! =-1 the sign change across the north fold boundary
@@ -1155,5 +1155,5 @@
       ENDIF
 
-      
+
       !                                      ! North-South boundaries
       IF( .NOT. cd_type1 == 'F' )   ptab1(:,     1       :jprecj,:) = 0.e0    ! south except at F-point
@@ -1165,5 +1165,5 @@
       ! 2. East and west directions exchange
       ! ------------------------------------
-      ! we play with the neigbours AND the row number because of the periodicity 
+      ! we play with the neigbours AND the row number because of the periodicity
       !
       SELECT CASE ( nbondi )      ! Read Dirichlet lateral conditions
@@ -1181,5 +1181,5 @@
       imigr = jpreci * jpj * jpk *2
       !
-      SELECT CASE ( nbondi ) 
+      SELECT CASE ( nbondi )
       CASE ( -1 )
          CALL mppsend( 2, t4we(1,1,1,1,1), imigr, noea, ml_req1 )
@@ -1208,5 +1208,5 @@
             ptab2(iihom+jl,:,:) = t4ew(:,jl,:,2,2)
          END DO
-      CASE ( 0 ) 
+      CASE ( 0 )
          DO jl = 1, jpreci
             ptab1(jl      ,:,:) = t4we(:,jl,:,1,2)
@@ -1240,5 +1240,5 @@
       imigr = jprecj * jpi * jpk * 2
       !
-      SELECT CASE ( nbondj )     
+      SELECT CASE ( nbondj )
       CASE ( -1 )
          CALL mppsend( 4, t4sn(1,1,1,1,1), imigr, nono, ml_req1 )
@@ -1252,5 +1252,5 @@
          IF(l_isend) CALL mpi_wait(ml_req1, ml_stat, ml_err)
          IF(l_isend) CALL mpi_wait(ml_req2, ml_stat, ml_err)
-      CASE ( 1 ) 
+      CASE ( 1 )
          CALL mppsend( 3, t4ns(1,1,1,1,1), imigr, noso, ml_req1 )
          CALL mpprecv( 4, t4sn(1,1,1,1,2), imigr, noso )
@@ -1267,5 +1267,5 @@
             ptab2(:,ijhom+jl,:) = t4ns(:,jl,:,2,2)
          END DO
-      CASE ( 0 ) 
+      CASE ( 0 )
          DO jl = 1, jprecj
             ptab1(:,jl      ,:) = t4sn(:,jl,:,1,2)
@@ -1287,5 +1287,5 @@
          !
          SELECT CASE ( jpni )
-         CASE ( 1 )                                           
+         CASE ( 1 )
             CALL lbc_nfd      ( ptab1, cd_type1, psgn )   ! only for northern procs.
             CALL lbc_nfd      ( ptab2, cd_type2, psgn )
@@ -1293,5 +1293,5 @@
             CALL mpp_lbc_north( ptab1, cd_type1, psgn )   ! for all northern procs.
             CALL mpp_lbc_north (ptab2, cd_type2, psgn)
-         END SELECT 
+         END SELECT
          !
       ENDIF
@@ -1303,8 +1303,8 @@
       !!----------------------------------------------------------------------
       !!                  ***  routine mpp_lnk_2d_e  ***
-      !!                  
+      !!
       !! ** Purpose :   Message passing manadgement for 2d array (with halo)
       !!
-      !! ** Method  :   Use mppsend and mpprecv function for passing mask 
+      !! ** Method  :   Use mppsend and mpprecv function for passing mask
       !!      between processors following neighboring subdomains.
       !!            domain parameters
@@ -1315,5 +1315,5 @@
       !!                    nbondi : mark for "east-west local boundary"
       !!                    nbondj : mark for "north-south local boundary"
-      !!                    noea   : number for local neighboring processors 
+      !!                    noea   : number for local neighboring processors
       !!                    nowe   : number for local neighboring processors
       !!                    noso   : number for local neighboring processors
@@ -1351,5 +1351,5 @@
       IF( .NOT. cd_type == 'F' )   pt2d(:,  1-jprj   :  jprecj  ) = 0.e0    ! south except at F-point
                                    pt2d(:,nlcj-jprecj+1:jpj+jprj) = 0.e0    ! north
-                                
+
       !                                      ! East-West boundaries
       !                                           !* Cyclic east-west
@@ -1371,5 +1371,5 @@
          CASE ( 1 )     ;   CALL lbc_nfd        ( pt2d(1:jpi,1:jpj+jprj), cd_type, psgn, pr2dj=jprj )
          CASE DEFAULT   ;   CALL mpp_lbc_north_e( pt2d                    , cd_type, psgn               )
-         END SELECT 
+         END SELECT
          !
       ENDIF
@@ -1377,5 +1377,5 @@
       ! 2. East and west directions exchange
       ! ------------------------------------
-      ! we play with the neigbours AND the row number because of the periodicity 
+      ! we play with the neigbours AND the row number because of the periodicity
       !
       SELECT CASE ( nbondi )      ! Read Dirichlet lateral conditions
@@ -1463,5 +1463,5 @@
       !
       !                           ! Write Dirichlet lateral conditions
-      ijhom = nlcj - jprecj  
+      ijhom = nlcj - jprecj
       !
       SELECT CASE ( nbondj )
@@ -1475,5 +1475,5 @@
             pt2d(:,ijhom+jl ) = r2dns(:,jl,2)
          END DO
-      CASE ( 1 ) 
+      CASE ( 1 )
          DO jl = 1, iprecj
             pt2d(:,jl-jprj) = r2dsn(:,jl,2)
@@ -1487,5 +1487,5 @@
       !!----------------------------------------------------------------------
       !!                  ***  routine mppsend  ***
-      !!                   
+      !!
       !! ** Purpose :   Send messag passing array
       !!
@@ -1523,5 +1523,5 @@
       INTEGER , INTENT(in   ) ::   kbytes     ! suze of the array pmess
       INTEGER , INTENT(in   ) ::   ktyp       ! Tag of the recevied message
-      INTEGER, OPTIONAL, INTENT(in) :: ksource    ! source process number 
+      INTEGER, OPTIONAL, INTENT(in) :: ksource    ! source process number
       !!
       INTEGER :: istatus(mpi_status_size)
@@ -1531,5 +1531,5 @@
       !
 
-      ! If a specific process number has been passed to the receive call, 
+      ! If a specific process number has been passed to the receive call,
       ! use that one. Default is to use mpi_any_source
       use_source=mpi_any_source
@@ -1546,6 +1546,6 @@
       !!----------------------------------------------------------------------
       !!                   ***  routine mppgather  ***
-      !!                   
-      !! ** Purpose :   Transfert between a local subdomain array and a work 
+      !!
+      !! ** Purpose :   Transfert between a local subdomain array and a work
       !!     array which is distributed following the vertical level.
       !!
@@ -1560,5 +1560,5 @@
       itaille = jpi * jpj
       CALL mpi_gather( ptab, itaille, mpi_double_precision, pio, itaille     ,   &
-         &                            mpi_double_precision, kp , mpi_comm_opa, ierror ) 
+         &                            mpi_double_precision, kp , mpi_comm_opa, ierror )
       !
    END SUBROUTINE mppgather
@@ -1569,5 +1569,5 @@
       !!                  ***  routine mppscatter  ***
       !!
-      !! ** Purpose :   Transfert between awork array which is distributed 
+      !! ** Purpose :   Transfert between awork array which is distributed
       !!      following the vertical level and the local subdomain array.
       !!
@@ -1591,5 +1591,5 @@
       !!----------------------------------------------------------------------
       !!                  ***  routine mppmax_a_int  ***
-      !! 
+      !!
       !! ** Purpose :   Find maximum value in an integer layout array
       !!
@@ -1597,5 +1597,5 @@
       INTEGER , INTENT(in   )                  ::   kdim   ! size of array
       INTEGER , INTENT(inout), DIMENSION(kdim) ::   ktab   ! input array
-      INTEGER , INTENT(in   ), OPTIONAL        ::   kcom   ! 
+      INTEGER , INTENT(in   ), OPTIONAL        ::   kcom   !
       !!
       INTEGER :: ierror, localcomm   ! temporary integer
@@ -1622,9 +1622,9 @@
       INTEGER, INTENT(inout)           ::   ktab      ! ???
       INTEGER, INTENT(in   ), OPTIONAL ::   kcom      ! ???
-      !! 
+      !!
       INTEGER ::   ierror, iwork, localcomm   ! temporary integer
       !!----------------------------------------------------------------------
       !
-      localcomm = mpi_comm_opa 
+      localcomm = mpi_comm_opa
       IF( PRESENT(kcom) )   localcomm = kcom
       !
@@ -1639,5 +1639,5 @@
       !!----------------------------------------------------------------------
       !!                  ***  routine mppmin_a_int  ***
-      !! 
+      !!
       !! ** Purpose :   Find minimum value in an integer layout array
       !!
@@ -1687,5 +1687,5 @@
       !!----------------------------------------------------------------------
       !!                  ***  routine mppsum_a_int  ***
-      !!                    
+      !!
       !! ** Purpose :   Global integer sum, 1D array case
       !!
@@ -1708,10 +1708,10 @@
       !!----------------------------------------------------------------------
       !!                 ***  routine mppsum_int  ***
-      !!                  
+      !!
       !! ** Purpose :   Global integer sum
       !!
       !!----------------------------------------------------------------------
       INTEGER, INTENT(inout) ::   ktab
-      !! 
+      !!
       INTEGER :: ierror, iwork
       !!----------------------------------------------------------------------
@@ -1727,5 +1727,5 @@
       !!----------------------------------------------------------------------
       !!                 ***  routine mppmax_a_real  ***
-      !!                  
+      !!
       !! ** Purpose :   Maximum
       !!
@@ -1751,5 +1751,5 @@
       !!----------------------------------------------------------------------
       !!                  ***  routine mppmax_real  ***
-      !!                    
+      !!
       !! ** Purpose :   Maximum
       !!
@@ -1762,5 +1762,5 @@
       !!----------------------------------------------------------------------
       !
-      localcomm = mpi_comm_opa 
+      localcomm = mpi_comm_opa
       IF( PRESENT(kcom) )   localcomm = kcom
       !
@@ -1774,5 +1774,5 @@
       !!----------------------------------------------------------------------
       !!                 ***  routine mppmin_a_real  ***
-      !!                  
+      !!
       !! ** Purpose :   Minimum of REAL, array case
       !!
@@ -1786,5 +1786,5 @@
       !!-----------------------------------------------------------------------
       !
-      localcomm = mpi_comm_opa 
+      localcomm = mpi_comm_opa
       IF( PRESENT(kcom) ) localcomm = kcom
       !
@@ -1798,9 +1798,9 @@
       !!----------------------------------------------------------------------
       !!                  ***  routine mppmin_real  ***
-      !! 
+      !!
       !! ** Purpose :   minimum of REAL, scalar case
       !!
       !!-----------------------------------------------------------------------
-      REAL(wp), INTENT(inout)           ::   ptab        ! 
+      REAL(wp), INTENT(inout)           ::   ptab        !
       INTEGER , INTENT(in   ), OPTIONAL :: kcom
       !!
@@ -1810,5 +1810,5 @@
       !!-----------------------------------------------------------------------
       !
-      localcomm = mpi_comm_opa 
+      localcomm = mpi_comm_opa
       IF( PRESENT(kcom) )   localcomm = kcom
       !
@@ -1822,5 +1822,5 @@
       !!----------------------------------------------------------------------
       !!                  ***  routine mppsum_a_real  ***
-      !! 
+      !!
       !! ** Purpose :   global sum, REAL ARRAY argument case
       !!
@@ -1831,9 +1831,9 @@
       !!
       INTEGER                   ::   ierror    ! temporary integer
-      INTEGER                   ::   localcomm 
-      REAL(wp), DIMENSION(kdim) ::   zwork     ! temporary workspace 
+      INTEGER                   ::   localcomm
+      REAL(wp), DIMENSION(kdim) ::   zwork     ! temporary workspace
       !!-----------------------------------------------------------------------
       !
-      localcomm = mpi_comm_opa 
+      localcomm = mpi_comm_opa
       IF( PRESENT(kcom) )   localcomm = kcom
       !
@@ -1847,5 +1847,5 @@
       !!----------------------------------------------------------------------
       !!                  ***  routine mppsum_real  ***
-      !!              
+      !!
       !! ** Purpose :   global sum, SCALAR argument case
       !!
@@ -1854,9 +1854,9 @@
       INTEGER , INTENT(in   ), OPTIONAL ::   kcom
       !!
-      INTEGER  ::   ierror, localcomm 
+      INTEGER  ::   ierror, localcomm
       REAL(wp) ::   zwork
       !!-----------------------------------------------------------------------
       !
-      localcomm = mpi_comm_opa 
+      localcomm = mpi_comm_opa
       IF( PRESENT(kcom) ) localcomm = kcom
       !
@@ -1891,6 +1891,6 @@
 
    END SUBROUTINE mppsum_realdd
-  
-  
+
+
    SUBROUTINE mppsum_a_realdd( ytab, kdim, kcom )
       !!----------------------------------------------------------------------
@@ -1918,5 +1918,5 @@
 
    END SUBROUTINE mppsum_a_realdd
-   
+
    SUBROUTINE mpp_minloc2d( ptab, pmask, pmin, ki,kj )
       !!------------------------------------------------------------------------
@@ -2013,5 +2013,5 @@
       REAL(wp)                     , INTENT(  out) ::   pmax     ! Global maximum of ptab
       INTEGER                      , INTENT(  out) ::   ki, kj   ! index of maximum in global frame
-      !!  
+      !!
       INTEGER  :: ierror
       INTEGER, DIMENSION (2)   ::   ilocs
@@ -2052,5 +2052,5 @@
       REAL(wp)                         , INTENT(  out) ::   pmax         ! Global maximum of ptab
       INTEGER                          , INTENT(  out) ::   ki, kj, kk   ! index of maximum in global frame
-      !!   
+      !!
       REAL(wp) :: zmax   ! local maximum
       REAL(wp), DIMENSION(2,1) ::   zain, zaout
@@ -2082,5 +2082,5 @@
       !!----------------------------------------------------------------------
       !!                  ***  routine mppsync  ***
-      !!                   
+      !!
       !! ** Purpose :   Massively parallel processors, synchroneous
       !!
@@ -2097,5 +2097,5 @@
       !!----------------------------------------------------------------------
       !!                  ***  routine mppstop  ***
-      !!                   
+      !!
       !! ** purpose :   Stop massively parallel processors method
       !!
@@ -2113,5 +2113,5 @@
       !!----------------------------------------------------------------------
       !!                  ***  routine mppobc  ***
-      !! 
+      !!
       !! ** Purpose :   Message passing manadgement for open boundary
       !!     conditions array
@@ -2124,5 +2124,5 @@
       !!                    nbondi : mark for "east-west local boundary"
       !!                    nbondj : mark for "north-south local boundary"
-      !!                    noea   : number for local neighboring processors 
+      !!                    noea   : number for local neighboring processors
       !!                    nowe   : number for local neighboring processors
       !!                    noso   : number for local neighboring processors
